import xbmc
import xbmcgui
import json
import xbmcplugin

def play_mpd_content(mpd_info, addon_handle):
    try:
        mpd_info = mpd_info.replace("'", '"')
        channel = json.loads(mpd_info)
        if channel and 'mpd_url' in channel:
            user_agent = 'User-Agent=Mozilla/5.0 (Web0S; Linux/SmartTV) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/94.0.4606.128 Safari/537.36 WebAppManager'
            xbmc.log(f"Channel data: {channel}", level=xbmc.LOGINFO)
            play_url = channel['mpd_url']

            list_item = xbmcgui.ListItem(path=play_url)

            # Imposta le chiavi ClearKey
            if 'license_key' in channel:
                hex_key = channel['license_key']
                list_item.setProperty('inputstream.adaptive.drm_legacy', 'org.w3.clearkey|' + hex_key)
            
            # Aggiungi stream_params solo per MPD specifici
            if "mpd" in play_url:
                list_item.setProperty('inputstream', 'inputstream.adaptive')
                list_item.setProperty('inputstream.adaptive.manifest_type', 'mpd')
                list_item.setProperty('inputstream.adaptive.stream_params', '?p=web')
                list_item.setProperty('inputstream.adaptive.stream_headers', user_agent)
                list_item.setProperty('inputstream.adaptive.manifest_headers', user_agent)
                list_item.setProperty('inputstream.adaptive.max_resolution', 'max')

            # Risolvi l'URL
            xbmcplugin.setResolvedUrl(addon_handle, True, listitem=list_item)
        else:
                xbmc.log("Canale non trovato o manca l'URL MPD", level=xbmc.LOGERROR)
    except Exception as e:
        xbmc.log(f"Errore generale in play_mpd_content: {str(e)}", level=xbmc.LOGERROR)
        xbmcgui.Dialog().notification('Errore', 'Errore durante la riproduzione MPD', xbmcgui.NOTIFICATION_ERROR, 5000)
